/*
 * listing.h
 *
 * Copyright 2000 Werner Fink, 2000 SuSE GmbH Nuernberg, Germany.
 *
 * This source is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#include <termios.h>
#include <unistd.h>
#if !defined(__STDC_VERSION__) || (__STDC_VERSION__ < 199901L)
# ifndef  inline
#  define inline		__inline__
# endif
# ifndef  restrict
#  define restrict		__restrict__
# endif
# ifndef  volatile
#  define volatile		__volatile__
# endif
# ifndef  asm
#  define asm			__asm__
# endif
# ifndef  extension
#  define extension		__extension__
# endif
# ifndef  typeof
#  define typeof		__typeof__
# endif
#endif
#ifndef  attribute
# define attribute(attr)	__attribute__(attr)
#endif
struct console {
    char * tty;
    int fd, tlock;
    ssize_t max_canon;
    struct termios ltio, otio;
    struct console * next;
};
extern void error (const char *fmt, ...) attribute((__noreturn__, __format__(__printf__, 1, 2)));
extern void warn  (const char *fmt, ...) attribute((__format__(__printf__, 1, 2)));
extern void pushd(const char *);
extern void popd(void);
extern char * fetchtty(const pid_t, const pid_t, dev_t *);
extern void secondtty(struct console *restrict, const dev_t);
extern void prepareIO(void (*rfunc)(int), void (*pfunc)(void), const pid_t, const int);
extern void safeIO (void);
extern void closeIO(void);
extern struct console *cons;
#define alignof(type)		((sizeof(type)+(sizeof(void*)-1)) & ~(sizeof(void*)-1))
#define strsize(string)		((strlen(string)+1)*sizeof(char))
